﻿<%@ Page Language="C#" MasterPageFile="~/Views/Shared/Site.Master" Inherits="System.Web.Mvc.ViewPage" %>
<asp:Content ID="indexTitle" ContentPlaceHolderID="TitleContent" runat="server">Home Page</asp:Content>
<asp:Content ContentPlaceHolderID="HeadContent" runat="server">
    <%--CSS Files--%>
    <link href="<%= Url.Content("~/Content/jquery-ui-1.8.17.css") %>" rel="stylesheet" type="text/css" />
    <link href="<%= Url.Content("~/Content/ui.jqgrid.css") %>" rel="stylesheet" type="text/css" />
    <style type="text/css">
        .myAltRowClass { background-color: #DCFFFF; background-image: none; }

        /* fix the size of the pager */
        input.ui-pg-input { width: auto; }
        div.ui-jqgrid-view table.ui-jqgrid-btable { border-style:none; /*border-top-style:none;*/ border-collapse:separate; }
        div.ui-jqgrid-view table.ui-jqgrid-btable td { border-left-style:none }
        div.ui-jqgrid-view table.ui-jqgrid-htable { border-style:none; /*border-top-style:none;*/ border-collapse:separate; }
        div.ui-jqgrid-view table.ui-jqgrid-btable th { border-left-style:none }
        
        /* fix the grid width */
        table { border-style:none; border-collapse:separate; }
        table td { border-style:none; }
        .ui-jqdialog-content table.group th {background-color:inherit}
        .ui-autocomplete {
            /* for IE6 which not support max-height it can be width: 350px; */
            max-height: 300px;
            overflow-y: auto;
            /* prevent horizontal scrollbar */
            overflow-x: hidden;
            /* add padding to account for vertical scrollbar */
            padding-right: 20px;
        }
        /*.ui-autocomplete.ui-menu { opacity: 0.9; }*/
        .ui-autocomplete.ui-menu .ui-menu-item { font-size: 0.75em; }
        .ui-autocomplete.ui-menu a.ui-state-hover { border-color: Tomato }
        .ui-resizable-handle {
            z-index: inherit !important;
        }
        .ui-jqgrid-pager .navtable .ui-pg-button .ui-pg-button-text { padding-right: 3px; }
        tr.ui-search-toolbar input { margin-top: 0.3em; }
    </style>

<%
   #if DEBUG
%>
    <%--jQuery Library--%>
    <script src="<%= Url.Content("~/Scripts/jquery-1.7.1.js") %>" type="text/javascript"></script>
    
    <%--Must load language tag BEFORE script tag--%>
    <script src="<%= Url.Content("~/Scripts/grid.locale-en.js") %>" type="text/javascript"></script>
    <script src="<%= Url.Content("~/Scripts/jquery.jqGrid.src.js") %>" type="text/javascript"></script>
    <script src="<%= Url.Content("~/Scripts/jquery-ui-1.8.17.js") %>" type="text/javascript"></script>
<%
   #else
%>
    <%--jQuery Library--%>
    <script src="<%= Url.Content("~/Scripts/jquery-1.7.1.min.js") %>" type="text/javascript"></script>
    
    <%--Must load language tag BEFORE script tag--%>
    <script src="<%= Url.Content("~/Scripts/grid.locale-en.js") %>" type="text/javascript"></script>
    <script src="<%= Url.Content("~/Scripts/jquery.jqGrid.min.js") %>" type="text/javascript"></script>
    <script src="<%= Url.Content("~/Scripts/jquery-ui-1.8.17.min.js") %>" type="text/javascript"></script>
<%
   #endif
%>
  
    <%--jqGrid Code - refer http://www.trirand.com/blog/jqgrid/jqgrid.html --%>
<%-- ReSharper disable InconsistentNaming --%>
    <script type="text/javascript">
//        $.extend($.jgrid.inlineEdit, {
//            restoreAfterError: false
//        });
        $(document).ready(function () {
            var $grid = $('#list'),
                decodeErrorMessage = function (jqXHR, textStatus, errorThrown) {
                    var html, errorInfo, i, errorText = textStatus + '\n' + errorThrown;
                    if (jqXHR.responseText.charAt(0) === '[') {
                        try {
                            errorInfo = $.parseJSON(jqXHR.responseText);
                            errorText = "";
                            for (i = 0; i < errorInfo.length; i++) {
                                if (errorText.length !== 0) {
                                    errorText += "<hr/>";
                                }
                                errorText += errorInfo[i].Source + ": " + errorInfo[i].Message;
                            }
                        }
                        catch (e) { }
                    } else {
                        html = /<body.*?>([\s\S]*)<\/body>/i.exec(jqXHR.responseText);
                        if (html !== null && html.length > 1) {
                            errorText = html[1];
                        }
                    }
                    return errorText;
                },
                clearError = function () {
                    $('#' + $.jgrid.jqID(this.id) + '_err').remove();
                },
                reportError = function (jqXHR, textStatus, errorThrown) {
                    // remove error div if exist
                    $('#' + $.jgrid.jqID(this.id) + '_err').remove();
                    // insert div with the error description before the grid
                    $(this).closest('div.ui-jqgrid').before(
                        '<div id="' + this.id + '_err" style="max-width:' + this.style.width +
                            ';"><div class="ui-state-error ui-corner-all" style="padding:0.7em;float:left;"><span class="ui-icon ui-icon-alert" style="float:left; margin-right: .3em;"></span><span style="clear:left">' +
                                decodeErrorMessage(jqXHR, textStatus, errorThrown) + '</span></div><div style="clear:left"/></div>');
                };

            $grid.jqGrid({
                url: '<%= Url.Action("DynamicGridData") %>',
                datatype: 'json',
                //mtype: 'POST',
                colNames: ['Id', 'Votes', 'Title'],
                colModel: [
                    { name: 'Id', index: 'Id', key: true, width: 40,
                        searchoptions: {
                            sopt: ['eq', 'ne', 'lt', 'le', 'gt', 'ge'],
                            dataInit: function (elem) {
                                // it demonstrates custom item rendering
                                $(elem).autocomplete({ source: '<%= Url.Action("GetIds") %>' })
                                    .data("autocomplete")._renderItem = function (ul, item) {
                                        return $("<li></li>")
                                            .data("item.autocomplete", item)
                                            .append("<a><span style='display: inline-block;width:60px;'><b>" + item.value + "</b></span>" + item.title + "</a>")
                                            .appendTo(ul);
                                    };
                            }
                        }
                    },
                    { name: 'Votes', index: 'Votes', width: 40,
                        searchoptions: { sopt: ['eq', 'ne', 'lt', 'le', 'gt', 'ge'] },
                        editable: true, editrules: { integer: true }
                    },
                    { name: 'Title', index: 'Title', width: 650,
                        searchoptions: {
                            sopt: ['cn', 'nc', 'bw', 'bn', 'eq', 'ne', 'ew', 'en', 'lt', 'le', 'gt', 'ge'],
                            dataInit: function (elem) {
                                $(elem).autocomplete({ source: '<%= Url.Action("GetTitleAutocomplete") %>' });
                            }
                        },
                        editable: true
                    }
                ],
                pager: '#pager',
                rowNum: 10,
                rowList: [5, 10, 20, 50],
                sortname: 'Id',
                sortorder: 'desc',
                rownumbers: true,
                viewrecords: true,
                altRows: true,
                altclass: 'myAltRowClass',
                height: '100%',
                gridview: true,
                jsonReader: { cell: "" },
                prmNames: { search: "search", nd: null },
                caption: 'My first grid',
                loadError: reportError,
                multiselect: true,
                loadComplete: function () {
                    // remove error div if exist
                    clearError.call(this);
                },
                onSelectRow: function (rowid) {
                    if (rowid !== null) {
                        $("#" + $.jgrid.jqID(this.id) + "_iledit").removeClass('ui-state-disabled');
                    } else {
                        $("#" + $.jgrid.jqID(this.id) + "_iledit").addClass('ui-state-disabled');
                    }
                },
                editurl: '<%= Url.Action("ModifyGridData") %>'
            });
            $grid.jqGrid('navGrid', '#pager', { add: false, edit: false, del: false },
                {}, {}, {}, { multipleSearch: true, overlay: false, width: 480 });
            $grid.jqGrid('filterToolbar', { stringResult: true, searchOnEnter: true, defaultSearch: 'cn' });
            $grid.jqGrid('navButtonAdd', '#pager', {
                caption: '<span class="ui-pg-button-text">Filter</span>',
                title: "Toggle Searching Toolbar",
                buttonicon: 'ui-icon-pin-s',
                onClickButton: function () {
                    this.toggleToolbar();
                }
            });
            $grid.jqGrid('navButtonAdd', '#pager', {
                caption: '<span class="ui-pg-button-text">Export</span>',
                buttonicon: "ui-icon-extlink",
                title: "Export To Excel",
                onClickButton: function () {
                    window.location = '<%= Url.Action("ExportAllQuestionsToExcel") %>';
                }
            });
            var afterSaveFunc = function (rowId, response) {
                var data = $.parseJSON(response.responseText);
                if ($.isPlainObject(data) && typeof data.Id !== "undefined" && typeof data.Votes !== "undefined") {
                    //$(this).jqGrid('setCell', rowId, 'Id', data.Id);
                    //$(this).jqGrid('setCell', rowId, 'Votes', data.Votes);
                    $(this).jqGrid('setRowData', rowId, { Id: data.Id, Votes: data.Votes });
                    $('#' + $.jgrid.jqID(rowId)).attr('id', data.Id);
                }
            },
                errorFunc = function (rowid, response, stat) {
                    reportError.call(this, response, stat);
                    //alert(response.responseText);
                };

            $grid.jqGrid('inlineNav', '#pager', {
                addParams: {
                    addRowParams: {
                        keys: true,
                        restoreAfterError: false,
                        // This is called if enter key is pressed to save added row
                        aftersavefunc: afterSaveFunc,
                        errorfunc: errorFunc
                    }
                },
                editParams: {
                    keys: true,
                    restoreAfterError: false,
                    // This is called if saver button in toolbar is pressed on inline add
                    aftersavefunc: afterSaveFunc,
                    errorfunc: errorFunc
                },
                add: true,
                edit: true,
                save: true,
                cancel: true
            });
            $("#" + $.jgrid.jqID($grid[0].id) + "_iledit").addClass('ui-state-disabled');
        });
    </script>  
<%-- ReSharper restore InconsistentNaming --%>
</asp:Content>

<asp:Content ContentPlaceHolderID="MainContent" runat="server">
    <%-- HTML Required--%>
    <h2>My Grid Data</h2>
    <table id="list"><tr><td></td></tr></table>
    <div id="pager"></div>
</asp:Content>